% Clark's Synthetic Hydrograph
tc=7;% Concentration Time
ts=0:tc;
Ti=ts/tc;
dt=1;
K=8;
Tend=30;

TAi(1:Tend)=0;
nloc1=find(Ti<0.5);
nloc2=find(Ti>=0.5);
TAi(nloc1)=1.414*Ti(nloc1).^1.5;
TAi(nloc2)=1-1.414*(1-Ti(nloc2)).^1.5;

C=2*dt/(2*K+dt);

IUH(1)=0;
for ih=2:30
    IUH(ih)=C*(TAi(ih)+TAi(ih-1))/2+(1-C)*IUH(ih-1);
    UH(ih-1)=(IUH(ih)+IUH(ih-1))/2;
end

plot(IUH,'LineWidth',2);set(gca,'FontSize',14)
hold on
plot(UH,'--xr','LineWidth',2);set(gca,'FontSize',14)
xlabel('t(hrs)','FontSize',14);
ylabel('Q (m^3/sec)','FontSize',14);
legend('IUH','UH')