clear
% Unit Hydrograph and S-hydrograph
delta_Tc=0.5;
delta_Tnew=1.5;
nd_dt=delta_Tnew/delta_Tc;
hc=[404,1079,2343,2506,1460,453, 381, 274, 173, 0, 0, 0];
nhc=length(hc);
% estimate gt
gt(1)=hc(1)*delta_Tc;
for is=2:nhc
    gt(is)=hc(is)*delta_Tc+gt(is-1);
end

gt_dt(1:nhc)=0;
gt_dt(nd_dt+1:nhc)=gt(1:nhc-nd_dt);
hc_new=1/delta_Tnew*(gt-gt_dt);
figure
plot(hc,'LineWidth',2);set(gca,'FontSize',14), hold on,
plot(hc_new,':xr'), 
plot(gt,'-.or'), 
hold off
legend('UH','UH-new','S-hydro')
xlabel('t(hrs)','FontSize',14);
ylabel('Q (m^3/sec)','FontSize',14);

